// aliados.cpp
// Revision 15-jan-2004

#include "cpm.h"

#include "realconsole.h"

#include <iostream>
#include <fstream>
using std::cin;
using std::cout;
using std::cerr;
using std::endl;
using std::flush;

//***********************************************
//			main
//***********************************************

int main (int argc, char * * argv)
{
	RealConsole console;
	CPM cpm (console);

	bool debugsystem= false;
	bool debugz80= false;
	bool raw= false;
	int argpos;
	for (argpos= 1; argpos < argc; ++argpos)
	{
		std::string arg (argv [argpos] );
		if (arg == "-d") // Debug all.
		{
			debugsystem= true;
			debugz80= true;
		}
		else if (arg == "-s") // Debug operating system.
		{
			debugsystem= true;
		}
		else if (arg == "-z") // Debug z80 code.
		{
			debugz80= true;
		}
		else if (arg == "--raw") // Console in raw mode.
			raw= true;
		else
			break;
	}

	if (argpos >= argc)
	{
		if (raw)
			console.raw ();
		cpm.interactive (debugsystem, debugz80);
	}
	else
	{
		// Load program file.

		if (! cpm.loadcommand (argv [argpos] ) )
		{
			cerr << "Error loading command" << endl;
			return 1;
		}

		// Build arguments.

		std::string args;
		++argpos;
		for ( ; argpos < argc; ++argpos)
		{
			std::string aux= argv [argpos];
			if (! aux.empty () )
			{
				args+= ' ';
				args+= aux;
			}
		}
		cerr << "Arguments: " << args << endl;
		cpm.setarguments (args);

		if (raw)
			console.raw ();
		cpm.tpastart (debugsystem, debugz80);
	}
}

// End of aliados.cpp
